> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Sign a crafting payload

> Sign a crafting payload



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json post /v1/chains/{chain_name}/crafting/sign
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /v1/chains/{chain_name}/crafting/sign:
    post:
      tags:
        - crafting
      summary: Sign a crafting payload
      description: Sign a crafting payload
      operationId: SignCraftingPayload
      parameters:
        - name: chain_name
          description: The name of chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainName'
          examples:
            testnet:
              value: imtbl-zkevm-testnet
              summary: Immutable zkEVM Public Testnet
      requestBody:
        description: The request body
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SignCraftingRequest'
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SignCraftingResult'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/UnauthorisedRequest'
        '403':
          $ref: '#/components/responses/ForbiddenRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - ImmutableApiKey:
            - create:collections
components:
  schemas:
    ChainName:
      type: string
      description: The name of chain
      example: imtbl-zkevm-testnet
    SignCraftingRequest:
      type: object
      properties:
        multi_caller:
          type: object
          properties:
            address:
              $ref: '#/components/schemas/Address'
            name:
              type: string
              description: The name of the multicaller contract
              example: Multicaller
            version:
              type: string
              description: The version of the multicaller contract
              example: '1'
          required:
            - address
            - name
            - version
        reference_id:
          type: string
          description: >-
            The id of this request in the system that originates the crafting
            request, specified as a 32 byte hex string
          example: 67f7d464b8f04f6a9a3b8d3cb4a21af0
        calls:
          type: array
          description: The calls to be signed
          items:
            $ref: '#/components/schemas/Call'
          minLength: 1
          maxLength: 100
        expires_at:
          type: string
          format: date-time
          description: The expiration time of the request
          example: '2022-08-16T17:43:26.991388Z'
      required:
        - multi_caller
        - reference_id
        - calls
        - expires_at
    SignCraftingResult:
      type: object
      properties:
        signer_address:
          $ref: '#/components/schemas/Address'
        signature:
          type: string
          description: The signature of the request
          example: '0x8a90cab2b38dba80c64b7734e58ee1db38b8992e'
      required:
        - signer_address
        - signature
    Address:
      x-go-type: common.Address
      x-go-type-import:
        path: github.com/ethereum/go-ethereum/common
        name: common
      description: An Ethereum address
      type: string
      example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
      pattern: ^0x[a-fA-F0-9]{40}$
    Call:
      type: object
      properties:
        target_address:
          $ref: '#/components/schemas/Address'
        function_signature:
          type: string
          description: The function signature
          example: mint(address,uint256)
        function_args:
          type: array
          items:
            type: string
          description: The function arguments
          example:
            - '0x8a90cab2b38dba80c64b7734e58ee1db38b8992e'
            - '1'
      required:
        - target_address
        - function_signature
        - function_args
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError401:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - UNAUTHORISED_REQUEST
              example: UNAUTHORISED_REQUEST
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError403:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - AUTHENTICATION_ERROR
              example: AUTHENTICATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError404:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - RESOURCE_NOT_FOUND
              example: RESOURCE_NOT_FOUND
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
  responses:
    BadRequest:
      description: Bad Request (400)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError400'
    UnauthorisedRequest:
      description: Unauthorised Request (401)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError401'
    ForbiddenRequest:
      description: Forbidden Request (403)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError403'
    NotFound:
      description: The specified resource was not found (404)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError404'
    InternalServerError:
      description: Internal Server Error (500)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError500'
  securitySchemes:
    ImmutableApiKey:
      x-go-name: ImmutableApiKey
      type: apiKey
      in: header
      name: x-immutable-api-key

````